#ifndef INCLUDE_H

#define INCLUDE_H

/* Standard Libraries */
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <malloc.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include <math.h>
#include <limits.h>
# include <fcntl.h> 
# include <time.h>
# include <setjmp.h>
# include <sys/types.h>
# include <float.h>
# include <sys/param.h>
# include <sys/stat.h>
# include "consts.h"


#ifndef REDF_FLOAT
#define REDF_FLOAT
#define real double
#endif

#ifndef LINESIZE
#define LINESIZE    512
#endif

#ifndef WORDSIZE
#define WORDSIZE     32
#endif

#ifndef __GNUC__
enum _bool { false, true };
typedef enum _bool bool;
#endif

#define MAX_SAFE_INPUT    32.0
#define VERY_BIG        1e37
#define LOG_VERY_BIG      85.195648
#define VERY_SMALL     1e-37
#define FALSE              0
#define TRUE               1

#ifndef MAXPATHLEN
#define MAXPATHLEN 1024
#endif

typedef int Boolean ;

#ifndef M_SQRT2
#define M_SQRT2 1.41421356237309504880
#endif

#endif
