#ifndef		MATRIX_H
#define		MATRIX_H

int    issingular(real **,int);
int    isposdef(real **,int);
real   invert_matrix(real **, real **, int);
real   log_trace(real **, int );
void   mult_up_low(real **, int, real **);
void   print_matrix(real **,int,int);
real   inner_matrix_product(real *, real *,real **,int );
real   weight_inner_matrix_prod(real *, real *,real **,real ,int );
void   resort_matrix(real **,int);
void   scale_matrix(real **,real,int,int);
void   add_matrices(real **, real **,int,int);
void   copy_matrix(real **, real **,int,int);
void   zero_matrix(real **,int,int);
void   rand_cov_matrix(real **,int ,real,int );
void   unity_matrix(real **,int n);
void   rand_matrix(real **,int ,real ,int,int );
real   trace_matrix(real **,int);
void   check_matrix(real **,int,int);
void   print_int_matrix(int **, int, int);
void   extend_vector(real *, real *, long);
void   print_vector(real *,int);
void   print_dvector(double *,int);
void   fprint_vector(FILE *, real *, int);
void   fprint_matrix(FILE *, real **, int, int);
void   outer_product(real **,real *, real *,int);
void   weight_outer_prod(real **,real *, real *,real,int);
real   weight_inner_prod(real *, real *, real, int);
real   inner_product(real *, real *, int);
real   diff_inner_product(real *, real *, int);
real   weight_diff_inner_prod(real *, real *, real, int);
void   scale_vector(real *,real,int);
void   add_vectors(real *, real *,int);
void   weight_add_vectors(real *, real *,real,int);
void   zero_vector(real *,int );
void   rand_prob_vector(real *,int,real,int );
void   rand_vector(real *,int ,real ,int );
real   max_vector(real *,int);
real   trace_vector(real *,int);
void   copy_vector(real *,real *,int);
void   vector_product(real *,real *,real *,int);
void   init_vector_sc(real *,real,int);
void   norm_vector(real *,int);
void   check_vector(real *,int);
float  max_vf(float *, int);
int    max_index_vf(float *, int);

 void     matCopy(real**, real**, int, int);
 void     matTran(real**, real**, int, int);
 void     matMult(real**, real**, real**, int, int, int);

#endif
